﻿'Name BbMouse1
Public Class Form1

    Dim x1 As Integer = -1, y1 As Integer      'PictureBox1用
    Dim x2 As Integer = -1, y2 As Integer      'PictureBox2用
    Dim DrawFlg As Boolean                     'Trueなら描画中
    Dim myPen As New Pen(Color.Black, 1)
    Dim myBrush As New SolidBrush(Color.Black)
    Dim myFont As New Font("Arial", 9)
    Dim g1, g2 As Graphics

    'Graphicsオブジェクトを設定する
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        g1 = PictureBox1.CreateGraphics()
        g2 = PictureBox2.CreateGraphics()
    End Sub

    'フォームのダブルクリックで説明文を表示する
    Private Sub Form1_DoubleClick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.DoubleClick
        g1.DrawString("折れ線描画", myFont, myBrush, 0, 0)
        g2.DrawString("フリーハンド描画", myFont, myBrush, 0, 0)
    End Sub

    'クリックした位置を結ぶ折れ線を描画する
    Private Sub PictureBox1_MouseDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles PictureBox1.MouseDown
        If e.Button = Windows.Forms.MouseButtons.Right Then  '右クリックなら
            g1.Clear(Color.White)              'PictureBox1をクリアする
            x1 = -1
        Else
            If x1 = -1 Then                    '現在何も描画されていないなら
                x1 = e.X : y1 = e.Y            '開始点保存
                g1.FillRectangle(myBrush, x1, y1, 1, 1) '点を打つ
            Else
                g1.DrawLine(myPen, x1, y1, e.X, e.Y)    '直線を引く
                x1 = e.X : y1 = e.Y            '次回描画の基点保存
            End If
        End If
    End Sub

    'フリーハンド描画開始
    Private Sub PictureBox2_MouseDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles PictureBox2.MouseDown
        If e.Button = Windows.Forms.MouseButtons.Right Then  '右クリックなら
            g2.Clear(Color.White)              'PictureBox1をクリアする
            x2 = -1
        Else
            x2 = e.X : y2 = e.Y                '基点を保存
            DrawFlg = True                     '描画中フラグを設定
        End If
    End Sub

    'フリーハンド描画中
    Private Sub PictureBox2_MouseMove(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles PictureBox2.MouseMove
        If DrawFlg = True Then
            g2.DrawLine(myPen, x2, y2, e.X, e.Y) '直線を引く
            x2 = e.X : y2 = e.Y                '次回描画の基点保存
        End If
    End Sub

    'フリーハンド描画終了
    Private Sub PictureBox2_MouseUp(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles PictureBox2.MouseUp
        DrawFlg = False                        '描画中フラグをクリア
    End Sub
End Class
