﻿'Name BbZuHilb
Public Class Form1
    Dim g As Graphics                      'Graphicsオブジェクト用変数

    '[ヒルベルト曲線]ボタン
    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Const GSIZE As Integer = 256       '描画全体ｻｲｽﾞ
        Dim ct, lenn, x, y As Integer
        Dim d As Integer                   '進行方向(90度ずつﾀｰﾝする)

        g = PictureBox1.CreateGraphics()   'Graphicsオブジェクトを取得
        g.Clear(PictureBox1.BackColor)     '領域クリア
        ct = 6               '位数6のヒルベルト曲線。位数を変えると絵も変化する
        lenn = GSIZE / (2 ^ ct)            '線の長さ
        x = GSIZE - GSIZE / (2 ^ (ct + 1)) '直線描画位置xを決定
        y = GSIZE / (2 ^ (ct + 1))         '直線描画位置yを決定
        d = 270                            '最初の進行方向
        drawA(ct - 1, x, y, d, lenn)       '描画開始
    End Sub

    'Aパターン描画
    Private Sub drawA(ByVal ct As Integer, ByRef x As Integer, ByRef y As Integer, ByRef d As Integer, ByVal lenn As Integer)
        If ct < 0 Then Exit Sub
        d = d - 90 : drawB(ct - 1, x, y, d, lenn) : myDrawLine(x, y, d, lenn)
        d = d + 90 : drawA(ct - 1, x, y, d, lenn) : myDrawLine(x, y, d, lenn)
        drawA(ct - 1, x, y, d, lenn) : d = d + 90 : myDrawLine(x, y, d, lenn)
        drawB(ct - 1, x, y, d, lenn) : d = d - 90
    End Sub

    'Bパターン描画
    Private Sub drawB(ByVal ct As Integer, ByRef x As Integer, ByRef y As Integer, ByRef d As Integer, ByVal lenn As Integer)
        If ct < 0 Then Exit Sub
        d = d + 90 : drawA(ct - 1, x, y, d, lenn) : myDrawLine(x, y, d, lenn)
        d = d - 90 : drawB(ct - 1, x, y, d, lenn) : myDrawLine(x, y, d, lenn)
        drawB(ct - 1, x, y, d, lenn) : d = d - 90 : myDrawLine(x, y, d, lenn)
        drawA(ct - 1, x, y, d, lenn) : d = d + 90
    End Sub

    '(x,y)からd方向に長さlennの線を引く
    Private Sub myDrawLine(ByRef x As Integer, ByRef y As Integer, ByRef d As Integer, ByVal lenn As Integer)
        Dim oldx, oldy As Integer

        If d < 0 Then d = d + 360
        If d >= 360 Then d = d - 360
        oldx = x : oldy = y
        Select Case d
            Case 0 : x = x + lenn
            Case 90 : y = y - lenn
            Case 180 : x = x - lenn
            Case 270 : y = y + lenn
        End Select
        g.DrawLine(Pens.Black, oldx, oldy, x, y)
    End Sub
End Class
