﻿'Name BbORide1
Public Class Form1

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Dim sqr As New Square()     'Squareのオブジェクトを指定
        Dim cub As New Cube()       'Cubeのオブジェクトを指定

        Debug.WriteLine("-----sqr")
        sqr.setData(10, 20)         '引数2個型のsetData
        sqr.dispData()              '長方形のdispData

        Debug.WriteLine("-----cub")
        cub.setData(10, 20, 30)     '引数3個型のsetData。x=10,y=20,z=30になる(1)
        cub.dispData()              '直方体のdispData
        cub.setData(5, 6)           '引数2個型のsetData。x=5,y=6だけ変更(2)
        cub.dispData()              '直方体のdispData
    End Sub
End Class

Public Class Square                 '基本クラス
    Protected x, y As Integer

    'このメソッドはオーバーロード対象であると表明する
    Public Overloads Sub setData(ByVal n1 As Integer, ByVal n2 As Integer)
        x = n1 : y = n2
    End Sub

    'このメソッドはオーバーライド可能であると表明する
    Public Overridable Sub dispData()
        Debug.WriteLine("長方形面積=" & x * y)
    End Sub
End Class

Public Class Cube                   '派生クラス
    Inherits Square                 '継承指定

    Private z As Integer            '追加の変数

    '親クラスの同名のメソッドをオーバーロードする
    Public Overloads Sub setData(ByVal n1 As Integer, ByVal n2 As Integer, ByVal n3 As Integer)
        x = n1 : y = n2 : z = n3
    End Sub

    '親クラスの同名のメソッドをオーバーライドする
    Public Overrides Sub dispData()
        Debug.WriteLine("直方体体積=" & x * y * z)
    End Sub
End Class