﻿'Name BbTFile1 
Public Class Form1
    Dim myFile As String = ""   'ファイル名を保存する

    '起動時に新規作成状態にする
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        newFile()
    End Sub

    '[新規作成]ボタン
    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        newFile()
    End Sub

    '[開く]ボタン
    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        '<ファイルを開く>ダイアログボックスを表示
        OpenFileDialog1.Filter = "txtファイル(*.txt)|*.txt"
        If OpenFileDialog1.ShowDialog() = Windows.Forms.DialogResult.OK Then
            myFile = OpenFileDialog1.FileName    'ファイル名取得
        End If
        If myFile <> "" Then myFileLoad() 'ファイル読み込み
    End Sub

    '[上書保存]ボタン
    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        If myFile = "" Then
            MsgBox("[名前を付けて保存]ボタンを使ってください。")
        Else
            myFileSave()
        End If
    End Sub

    '[名前を付けて保存]ボタン
    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click
        '<名前を付けて保存>ダイアログボックスを表示()
        SaveFileDialog1.Filter = "txtファイル(*.txt)|*.txt"
        If SaveFileDialog1.ShowDialog() = Windows.Forms.DialogResult.OK Then
            myFile = SaveFileDialog1.FileName  'ファイル名取得
        End If
        If myFile <> "" Then myFileSave() 'ファイル書き込み
    End Sub

    '新規ファイルの設定にする
    Private Sub newFile()
        TextBox1.Text = ""           'テキストボックスをクリア
        myFile = ""                  'ファイル名を未登録にする
        Me.Text = "無題"             'タイトルバーをこの表示にする
    End Sub

    'テキストボックスにファイル内容を読み込む
    Private Sub myFileLoad()
        Try                          'ファイルから全内容を読み込む
            TextBox1.Text = My.Computer.FileSystem.ReadAllText(myFile, System.Text.Encoding.Default)
            Me.Text = myFile         'タイトルバーにファイル名表示
        Catch                        'エラーのときはここにくる
            MsgBox("読込エラーです。")
        End Try
    End Sub

    'テキストボックス内容をファイルに書き込む
    Private Sub myFileSave()
        Try                         'TextBox1の全内容を書き込む
            My.Computer.FileSystem.WriteAllText(myFile, TextBox1.Text, False, System.Text.Encoding.Default)
            Me.Text = myFile        'タイトルバーにファイル名表示
        Catch                       'エラーのときはここにくる
            MsgBox("書込エラーです。")
        End Try
    End Sub
End Class
