﻿'Name BbZuGlb3
Public Class Form1
    Const HANKEI As Integer = 140         '円の半径
    Const XBASE As Integer = 150          '円の中心X
    Const YBASE As Integer = 150          '円の中心Y
    Const toRad As Double = Math.PI / 180 '角度→ラジアン変換用
    Const R2 As Double = 140.0 * 140.0 - 1.0 '半径*半径より僅かに小さい値

    '[球(陰影処理)]ボタン
    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click

        Dim g As Graphics = PictureBox1.CreateGraphics()
        Dim x, y, z As Double
        Dim x2, y2 As Double
        Dim xx, yy As Integer             'x2,y2の整数表現を入れる
        Dim degZ As Double                '2次元(x-y面)回転角度
        Dim degY As Double                '3次元(x-z面)回転角度
        Dim frontFlg As Boolean           '前面描画中
        Dim onCircleFlg As Boolean        '円の外周を描画中

        g.Clear(PictureBox1.BackColor)    '領域クリア

        '横線を描画
        For degZ = 90 To -90 Step -10     '緯度を10度きざみにする
            x = HANKEI * Math.Cos(degZ * toRad)
            y = HANKEI * Math.Sin(degZ * toRad)
            For degY = -90 To 90 Step 0.5
                z = x * Math.Sin(degY * toRad)
                x2 = x * Math.Cos(degY * toRad)
                xx = CInt(x2)
                y2 = y * Math.Cos(30 * toRad) + z * Math.Cos(60 * toRad)
                yy = CInt(y2)
                If degZ >= -50 Then
                    g.DrawLine(Pens.White, XBASE - xx, yy + YBASE, _
                                           XBASE + xx, yy + YBASE) '白で消去
                End If                                             '↓緯度表示
                g.FillRectangle(Brushes.Black, XBASE + xx, YBASE + yy, 1, 1)
                g.FillRectangle(Brushes.Black, XBASE - xx, YBASE + yy, 1, 1)
            Next
        Next

        '縦線を描画
        For degY = 0 To 180 Step 10       '経度を10度きざみにする
            frontFlg = True : onCircleFlg = False
            For degZ = -90 To 270 Step 0.5
                x = HANKEI * Math.Cos(degZ * toRad)
                y = HANKEI * Math.Sin(degZ * toRad)
                z = x * Math.Sin(degY * toRad)
                x2 = x * Math.Cos(degY * toRad)
                xx = CInt(x2)
                y2 = y * Math.Cos(30 * toRad) + z * Math.Cos(60 * toRad)
                yy = CInt(y2)
                If (x2 * x2 + y2 * y2) >= R2 Then  '円の外周上にきたら
                    If onCircleFlg = False Then frontFlg = Not frontFlg
                    onCircleFlg = True
                Else
                    onCircleFlg = False
                End If
                If frontFlg = True Or onCircleFlg = True Then
                    g.FillRectangle(Brushes.Black, xx + XBASE, yy + YBASE, 1, 1)
                End If                    '↑経度表示
            Next
        Next
    End Sub
End Class
